/*
 * Copyright 2012 ETH Zuerich, CISD
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ch.systemsx.cisd.openbis.uitest.page.tab;

import ch.systemsx.cisd.openbis.uitest.infra.webdriver.Locate;
import ch.systemsx.cisd.openbis.uitest.widget.SubmitButton;
import ch.systemsx.cisd.openbis.uitest.widget.Text;

public class LoginPage
{
    @Locate("openbis_login_username")
    private Text username;

    @Locate("openbis_login_password")
    private Text password;

    @Locate("openbis_login_submit")
    private SubmitButton button;

    public void loginAs(String user, String pwd)
    {
        username.write(user);
        password.write(pwd);
        button.click();
    }
}
